<template>
  <div
    ref="navbar"
    class="ui-navbar bg-white shadow"
    :class="sticky ? 'sticky top-0 z-10' : ''"
  >
    <nav
      :role="navRole"
      class="flex flex-wrap items-center justify-between px-4 py-3 xl:container md:flex-nowrap lg:px-6 xl:mx-auto"
    >
      <div class="mr-2 grow-0 md:mr-4 lg:mr-8">
        <slot name="brand">
          <router-link
            class="rounded text-xl font-bold text-violet-700 outline-none hover:text-violet-900 focus:ring-2 focus:ring-violet-700 lg:text-2xl xl:text-4xl"
            :to="brand.to"
          >
            {{ brand.name }}
          </router-link>
        </slot>
      </div>

      <!-- Mobile menu button -->
      <ui-navbar-toggle-button
        v-if="!supportNoScript || javaScriptEnabled"
        class="md:hidden"
        aria-controls="navbar-list"
        :open="open"
        @click="toggleMenu()"
      >
        {{ toggleButtonLabel }}
      </ui-navbar-toggle-button>

      <!-- Mobile Menu open: "block", Menu closed: "hidden" -->
      <ui-navbar-list id="navbar-list" :class="{ 'hidden md:flex': !open }">
        <slot>
          <ui-navbar-list-item
            v-for="(item, index) of navbarItems"
            :key="index"
            v-bind="{
              ...(item.tag ? { tag: item.tag } : {}),
              ...(item.to ? { to: item.to } : {}),
              ...(item.href ? { href: item.href } : {}),
              ...(item.external ? { external: item.external } : {}),
              ...(item.label ? { label: item.label } : {}),
              ...(item.matchNonExactRoute
                ? { matchNonExactRoute: item.matchNonExactRoute }
                : {}),
              ...(item.onClick ? { onClick: item.onClick } : {}),
            }"
          >
            <template #iconLeft>
              <ui-svg-icon v-if="item.iconLeft" :name="item.iconLeft" />
            </template>
            {{ item.label }}
            <template #iconRight>
              <ui-svg-icon v-if="item.iconRight" :name="item.iconRight" />
            </template>
          </ui-navbar-list-item>
        </slot>
        <ui-navbar-list-item v-if="languageSelect" wrapper-only>
          <ui-language-select
            v-bind="languageSelect"
            :support-no-script="supportNoScript"
            class="self-end md:self-center"
            @update="
              ($localeCode: String) => $emit('update:language', $localeCode)
            "
          />
        </ui-navbar-list-item>
      </ui-navbar-list>
    </nav>
  </div>
</template>

<script lang="ts" setup>
import { onMounted, PropType, ref } from 'vue'
import { RouterLink } from 'vue-router'
import { onClickOutside } from '@vueuse/core'
import {
  LanguageSelectOptions,
  NavbarBrand,
  NavbarItemProps,
} from '../../propInterfaces'
import UiLanguageSelect from './LanguageSelect.vue'
import UiNavbarList from './NavbarList.vue'
import UiNavbarListItem from './NavbarListItem.vue'
import UiNavbarToggleButton from './NavbarToggleButton.vue'
import UiSvgIcon from './SvgIcon.vue'

defineOptions({
  name: 'UiNavbar',
})

const props = defineProps({
  brand: {
    type: Object as PropType<NavbarBrand>,
    default: () => ({ name: 'Brand Name', to: '/' }),
  },

  navbarItems: {
    type: Array as PropType<NavbarItemProps[]>,
    default: () => [],
  },

  navRole: {
    type: String,
    default: 'navigation',
  },

  sticky: {
    type: Boolean,
    default: false,
  },

  toggleButtonLabel: {
    type: String,
    default: 'Menu',
  },

  languageSelect: {
    type: Object as PropType<LanguageSelectOptions>,
    default: undefined,
  },

  supportNoScript: {
    type: Boolean,
    default: true,
  },
})

defineEmits(['update:language'])

const open = ref(!!props.supportNoScript)
const javaScriptEnabled = ref(false)

onMounted(() => {
  open.value = false
  javaScriptEnabled.value = true
})

const toggleMenu = () => (open.value = !open.value)

/* close mobile NavbarList if the user clicked outside of it */
const navbar = ref(null)

onClickOutside(navbar, () => {
  if (open.value) {
    toggleMenu()
  }
})
</script>
